"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function OnChange(callback) {
    var _cachedValue;
    var _isFirstChange = true;
    return function (target, key) {
        Object.defineProperty(target, key, {
            set: function (value) {
                // No operation if new value is same as old value
                if (!_isFirstChange && _cachedValue === value) {
                    return;
                }
                var oldValue = _cachedValue;
                _cachedValue = value;
                var simpleChange = {
                    firstChange: _isFirstChange,
                    previousValue: oldValue,
                    currentValue: _cachedValue,
                    isFirstChange: function () { return _isFirstChange; },
                };
                _isFirstChange = false;
                callback.call(this, _cachedValue, simpleChange);
            },
            get: function () {
                return _cachedValue;
            },
        });
    };
}
exports.OnChange = OnChange;
